Bug 978587 - Review Request: eclipse-testng - TestNG plug-in for Eclipse
Review Request: eclipse-testng - TestNG plug-in for Eclipse
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Roland Grunberg
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-26 16:59 EDT by Mat Booth
Modified: 2014-06-19 04:17 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-06-19 04:17:34 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rgrunber: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)
Patch to fix auto-requires for dir-shaped osgi bundles (794 bytes, patch)
2014-06-17 05:32 EDT, Mat Booth
no flags Details | Diff

  None (edit)
Description Mat Booth 2013-06-26 16:59:04 EDT
Spec URL: http://mbooth.fedorapeople.org/reviews/eclipse-testng.spec
SRPM URL: http://mbooth.fedorapeople.org/reviews/eclipse-testng-6.8.5-1.20130625gite0f6037.fc19.src.rpm

Description: The Eclipse TestNG plug-in integrates the TestNG testing framework into the Eclipse IDE.
Fedora Account System Username: mbooth
Comment 1 Mat Booth 2013-06-26 17:22:32 EDT
Scratch Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5548930
Comment 3 Mat Booth 2014-03-14 12:05:48 EDT
Notes:

* rpmlint will throw up some warnings, but these are benign and expected
* scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=6633147
Comment 4 Mat Booth 2014-06-12 12:08:58 EDT
Spec URL: http://fedorapeople.org/~mbooth/reviews/eclipse-testng.spec
SRPM URL: http://fedorapeople.org/~mbooth/reviews/eclipse-testng-6.8.6-2.fc21.src.rpm

Updated to latest upstream release and patch for Luna compatibility.

Latest rawhide scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=7040204
Comment 5 Roland Grunberg 2014-06-16 16:52:14 EDT
Reviewed initially using 'fedora-review -b 978587 -P Java -m fedora-rawhide-x86_64'

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======

It seems auto-{provides,requires} are not generated because of the Bundle-ClassPath manifest attribute. It would be nice to change these to Require-Bundle (I believe the listed libraries have proper manifests), and make the libraries visible to others (through dropins) but I think the current state of Bundle-ClassPath + symlinking is fine for now.

[x]: Requires correct, justified where necessary.
- Package requires snakeyaml, and beust-jcommander at build/runtime but does not explicitly list these in BuildRequires or as a requirement of the binary rpm. Given that eclipse-testng will always depend on testng, which has its own requires on these, I'm willing to accept this.

I'd like to know your thoughts on the above, but after that I think I'll have this approved.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "Unknown or generated". 161 files have unknown license.
     This is fine, feature plugin indicates this is ASL 2.0
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Maven:
[x]: If package contains pom.xml files install it (including depmaps) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
Tested on rawhide by starting package as part of Eclipse runtime.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
Comment 6 Mat Booth 2014-06-17 04:37:19 EDT
(In reply to Roland Grunberg from comment #5)
> Reviewed initially using 'fedora-review -b 978587 -P Java -m
> fedora-rawhide-x86_64'
> 
> Package Review
> ==============
> 
> Legend:
> [x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
> 
> 
> Issues:
> =======
> 
> It seems auto-{provides,requires} are not generated because of the
> Bundle-ClassPath manifest attribute. It would be nice to change these to
> Require-Bundle (I believe the listed libraries have proper manifests), and
> make the libraries visible to others (through dropins) but I think the
> current state of Bundle-ClassPath + symlinking is fine for now.
> 
> [x]: Requires correct, justified where necessary.
> - Package requires snakeyaml, and beust-jcommander at build/runtime but does
> not explicitly list these in BuildRequires or as a requirement of the binary
> rpm. Given that eclipse-testng will always depend on testng, which has its
> own requires on these, I'm willing to accept this.
> 
> I'd like to know your thoughts on the above, but after that I think I'll
> have this approved.
> 
> 

You're absolutely right, all the deps appear to have osgi metadata in both F20 and rawhide.

In fact, doing it this way with Require-Bundle required I symlink additional deps (all transient deps of the deps listed in the BR/Rs) in order to fully resolve them -- the TestNG plug-in must not exercise the code paths that require these deps because I've been using this package in real life for a long time without issue.
Comment 7 Mat Booth 2014-06-17 05:31:19 EDT
Here is the latest spec/srpm using Require-Bundle instead of Bundle-Classpath:

Spec URL: http://fedorapeople.org/~mbooth/reviews/eclipse-testng.spec
SRPM URL: http://fedorapeople.org/~mbooth/reviews/eclipse-testng-6.8.6-3.fc21.src.rpm

However, I have discovered that the real reason that "osgi()" requires are not generated is because there is a bug in the /usr/lib/rpm/osgi.req -- it does not handle dir-shaped bundles. I will file a bug separately, but the patch if you want to test it locally is attached.
Comment 8 Mat Booth 2014-06-17 05:32:59 EDT
Created attachment 909491 [details]
Patch to fix auto-requires for dir-shaped osgi bundles
Comment 9 Mat Booth 2014-06-17 06:05:44 EDT
I submitted a slightly better patch in the pull request: https://github.com/mizdebsk/javapackages/pull/1
Comment 10 Roland Grunberg 2014-06-17 11:48:17 EDT
Thanks for doing this!

[x]: Requires correct, justified where necessary.

However, adopting the new changes has introduced an issue. it looks like org.eclipse.testng is being hit by the javax.annotation 'uses' conflict between guava and org.eclipse.core.runtime on rawhide :

org.osgi.service.resolver.ResolutionException: Uses constraint violation. Unable to resolve resource org.testng.eclipse [osgi.identity; osgi.identity="org.testng.eclipse"; type="osgi.bundle"; version:Version="6.8.6.201406171013"; singleton:="true"] because it is exposed to package 'javax.annotation' from resources org.eclipse.osgi [osgi.identity; osgi.identity="org.eclipse.osgi"; type="osgi.bundle"; version:Version="3.10.0.v20140606-1342"; singleton:="true"] and org.apache.geronimo.specs.geronimo-annotation_1.1_spec [osgi.identity; singleton="true"; osgi.identity="org.apache.geronimo.specs.geronimo-annotation_1.1_spec"; type="osgi.bundle"; version:Version="1.0.0"; singleton:="true"] via two dependency chains.

I've filed it as Bug 1110413 .

Regarding, '[x]: Package functions as described.', even with the above issue on rawhide, this package does build, install and resolve on f20 in the Eclipse runtime. Given that the mentioned issue is being looked into, I don't think we should hold off (especially when efforts have been made to adopt best practices).

================
*** APPROVED ***
================
Comment 11 Mat Booth 2014-06-17 12:04:11 EDT
New Package SCM Request
=======================
Package Name: eclipse-testng
Short Description: TestNG plug-in for Eclipse
Upstream URL: http://testng.org
Owners: mbooth
Branches: f20
InitialCC:
Comment 12 Kevin Fenzi 2014-06-18 12:08:09 EDT
Git done (by process-git-requests).
Comment 13 Mat Booth 2014-06-19 04:17:34 EDT
Built for all requested branches.

Note You need to log in before you can comment on or make changes to this bug.